freeslot("S_PLAY_DRIBBLE")

local A_CheckIfStillDribble = function(actor,var1,var2)
	local p = actor.player
	if not p
	or (not p
	and (xor(p.rmomz >= 0, actor & MFE_VERTICALFLIP)
	or P_IsObjectOnGround(actor)))
		actor.state = S_PLAY_FALL
	end
end

states[S_PLAY_DRIBBLE] =
{
	sprite = SPR_PLAY,
	frame = SPR2_GLID,
	tics = -1,
	action = A_CheckIfStillDribble
}

local xor = function(a,b)
	if (a or b)
	and not (a and b)
		return true end
	return false
end

addHook("AbilitySpecial",function(p)
	if p
	and p.mo
	and p.mo.skin == "dribble"
	and not p.mo.dribbled
	and not (p.mo.eflags & MFE_GOOWATER)
		P_SetObjectMomZ(p.mo,-40*FRACUNIT)
		p.dribbled = true
		p.pflags = $|PF_THOKKED
		p.mo.state = S_PLAY_DRIBBLE
		p.powers[pw_strong] = (STR_MELEE|STR_STOMP)&~(STR_PUNCH|STR_ANIM)
		p.dribblesquash = -5
	end
end)

addHook("PlayerSpawn",function(p)
	if skins[p.skin].name == "dribble"
		p.dribbled = false
		p.dribblesquash = 0
		p.consecutivedribble = 0
		p.dashed = false
	end
end)

addHook("PlayerThink",function(p)
	if p
	and p.mo
	and p.mo.skin == "dribble"
		if p.dribblesquash > 0
			p.dribblesquash = $-1
		end
		
		if p.dribbled
		and (p.powers[pw_justsprung]
		or p.powers[pw_carry]
		or P_PlayerInPain(p)
		or p.playerstate != PST_LIVE
		or p.mo.eflags & MFE_GOOWATER
		or (xor(p.mo.momz > 0, p.mo.eflags & MFE_VERTICALFLIP)
		and not P_IsObjectOnGround(p.mo))
		or p.exiting
		or p.mo.state == S_PLAY_GASP)
			p.dribbled = false
			if p.mo.state == S_PLAY_DRIBBLE
				p.mo.state = S_PLAY_FALL
			end
		elseif P_IsObjectOnGround(p.mo)
		and p.dribbled
			p.dribbled = false
			S_StartSound(p.mo,sfx_boingf)
			p.mo.state = S_PLAY_DRIBBLE
			p.dribblesquash = 5
			p.consecutivedribble = min(5,$+1)
			
			local tester = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_GARGOYLE)
			tester.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			if p.speed == 0
				tester.angle = p.mo.angle
			else
				tester.angle = R_PointToAngle2(0,0,p.rmomx,p.rmomy)
			end
			local movedangle = tester.angle
			tester.radius = 1
			P_Move(tester,p.mo.radius/2)
			local frontheight = tester.floorz
			P_Move(tester,p.mo.radius/-1)
			local backheight = tester.floorz
			P_KillMobj(tester)
			
			if frontheight == backheight
				P_InstaThrust(p.mo,p.mo.angle,min(FixedHypot(p.mo.momx,p.mo.momy)*3/2,p.actionspd))
				P_SetObjectMomZ(p.mo,7*FRACUNIT)
			elseif frontheight > backheight
				P_InstaThrust(p.mo,movedangle,min(FixedHypot(p.mo.momx,p.mo.momy)/2,p.actionspd/4))
				P_SetObjectMomZ(p.mo,15*FRACUNIT)
			else
				P_InstaThrust(p.mo,movedangle,min(FixedHypot(p.mo.momx,p.mo.momy)*3,p.actionspd*3/2))
				P_SetObjectMomZ(p.mo,4*FRACUNIT)
			end
			
			P_SetObjectMomZ(p.mo,p.consecutivedribble * FRACUNIT,true)
			
			if p.mo.eflags & MFE_UNDERWATER
				p.mo.momz = $*2/3
			end
			
			p.pflags = $|PF_JUMPED
		end
		
		if not p.dribbled
			p.powers[pw_strong] = STR_NONE
			if p.dribblesquash < 0
				p.dribblesquash = $+1
			end
			if P_IsObjectOnGround(p.mo)
			and p.mo.momz == 0
			and p.consecutivedribble > 0
				p.consecutivedribble = 0
			end
		end
		
		if p.mo.state == S_PLAY_DRIBBLE
			p.mo.spritexscale = ease.linear(p.dribblesquash*FRACUNIT/10,FRACUNIT,FRACUNIT*2)
			p.mo.spriteyscale = ease.linear(p.dribblesquash*FRACUNIT/10,FRACUNIT,FRACUNIT/2)
		else
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT			
		end
		
		if p.pflags & PF_STARTDASH
			p.dashed = true
		elseif p.dashed
		and p.speed >= p.mindash
			p.dashed = false
			P_SetObjectMomZ(p.mo,7*FRACUNIT,false)
			if p.mo.eflags & MFE_UNDERWATER
				p.mo.momz = $*2/3
			end
			p.consecutivedribbles = 5
			p.pflags = ($|PF_JUMPED)&~PF_SPINNING
		end
	end
end)

addHook("PostThinkFrame",function()
	for p in players.iterate
		if p.dribbled
		and p.mo.state != S_PLAY_GASP
		and p.mo.state != S_PLAY_PAIN
		and p.playerstate == PST_LIVE
			p.mo.state = S_PLAY_DRIBBLE
			p.mo.sprite2 = SPR2_GLID
		end
	end
end)